Skip to content
Back to top
View this page
Edit this page

# slidge

The main slidge package.

Contains importable classes for a minimal function Legacy Module.

## Submodules

- slidge.command
- slidge.contact
- slidge.group
- slidge.main

## Classes

`BaseGateway` | The gateway component, handling registrations and un-registrations.
`BaseSession` | The session of a registered User.

## Functions

`entrypoint`(module_name) | Entrypoint to be used in `__main__.py` of

## Package Contents

class slidge.BaseGateway

  The gateway component, handling registrations and un-registrations.

  On slidge launch, a singleton is instantiated, and it will be made available to public classes such `LegacyContact` or `BaseSession` as the `.xmpp` attribute.

  Must be subclassed by a legacy module to set up various aspects of the XMPP component behaviour, such as its display name or welcome message, via class attributes `COMPONENT_NAME` `WELCOME_MESSAGE`.

  Abstract methods related to the registration process must be overriden for a functional Legacy Module:

  - `validate()`

  - `validate_two_factor_code()`

  - `get_qr_text()`

  - `confirm_qr()`

  NB: Not all of these must be overridden, it depends on the `REGISTRATION_TYPE`.

  The other methods, such as `send_text()` or `react()` are the same as those of `LegacyContact` and `LegacyParticipant`, because the component itself is also a “messaging actor”, ie, an XMPP Entity. For these methods, you need to specify the JID of the recipient with the mto parameter.

  Since it inherits from `slixmpp.componentxmpp.ComponentXMPP`,you also have a hand on low-level XMPP interactions via slixmpp methods, e.g.:

      self.send_presence(
          pfrom="somebody@component.example.com",
          pto="someonwelse@anotherexample.com",
      )

  However, you should not need to do so often since the classes of the plugin API provides higher level abstractions around most commonly needed use-cases, such as sending messages, or displaying a custom status.

  COMPONENT_NAME: str = NotImplemented

    Name of the component, as seen in service discovery by XMPP clients

  COMPONENT_TYPE: str = ''

    Type of the gateway, should follow https://xmpp.org/registrar/disco-categories.html

  COMPONENT_AVATAR: slidge.util.types.Avatar | pathlib.Path | str | None = None

    Path, bytes or URL used by the component as an avatar.

  REGISTRATION_FIELDS: Sequence[slidge.command.base.FormField]

    Iterable of fields presented to the gateway user when registering using XEP-0077 extended by XEP-0004.

  REGISTRATION_INSTRUCTIONS: str = 'Enter your credentials'

    The text presented to a user that wants to register (or modify) their legacy account configuration.

  REGISTRATION_TYPE: slidge.command.register.RegistrationType

    This attribute determines how users register to the gateway, ie, how they login to the legacy service. The credentials are then stored persistently, so this process should happen once per user (unless they unregister).

    The registration process always start with a basic data form (XEP-0004) presented to the user. But the legacy login flow might require something more sophisticated, see `RegistrationType` for more details.

  ROSTER_GROUP: str = 'slidge'

    Name of the group assigned to a `LegacyContact` automagically added to the User’s roster with `LegacyContact.add_to_roster()`.

  WELCOME_MESSAGE = "Thank you for registering. Type 'help' to list the available commands, or just start messaging away!"

    A welcome message displayed to users on registration. This is useful notably for clients that don’t consider component JIDs as a valid recipient in their UI, yet still open a functional chat window on incoming messages from components.

  SEARCH_FIELDS: Sequence[slidge.command.base.FormField]

    Fields used for searching items via the component, through XEP-0055 (jabber search). A common use case is to allow users to search for legacy contacts by something else than their usernames, eg their phone number.

    Plugins should implement search by overriding `BaseSession.search()` (restricted to registered users).

    If there is only one field, it can also be used via the `jabber:iq:gateway` protocol described in XEP-0100. Limitation: this only works if the search request returns one result item, and if this item has a ‘jid’ var.

  SEARCH_TITLE: str = 'Search for legacy contacts'

    Title of the search form.

  SEARCH_INSTRUCTIONS: str = ''

    Instructions of the search form.

  MARK_ALL_MESSAGES = False

    Set this to True for legacy networks that expects read marks for all messages and not just the latest one that was read (as most XMPP clients will only send a read mark for the latest msg).

  PROPER_RECEIPTS = False

    Set this to True if the legacy service provides a real equivalent of message delivery receipts (XEP-0184), meaning that there is an event thrown when the actual device of a contact receives a message. Make sure to call Contact.received() adequately if this is set to True.

  AVATAR_ID_TYPE: Callable[[str], Any]

    Modify this if the legacy network uses unique avatar IDs that are not strings.

    This is required because we store those IDs as TEXT in the persistent SQL DB. The callable specified here will receive is responsible for converting the serialised-as-text version of the avatar unique ID back to the proper type. Common example: `int`.

  LEGACY_MSG_ID_TYPE: Callable[[str], Any]

    Modify this if the legacy network uses unique message IDs that are not strings.

    This is required because we store those IDs as TEXT in the persistent SQL DB. The callable specified here will receive is responsible for converting the serialised-as-text version of the message unique ID back to the proper type. Common example: `int`.

  LEGACY_CONTACT_ID_TYPE: Callable[[str], Any]

    Modify this if the legacy network uses unique contact IDs that are not strings.

    This is required because we store those IDs as TEXT in the persistent SQL DB. The callable specified here is responsible for converting the serialised-as-text version of the contact unique ID back to the proper type. Common example: `int`.

  LEGACY_ROOM_ID_TYPE: Callable[[str], Any]

    Modify this if the legacy network uses unique room IDs that are not strings.

    This is required because we store those IDs as TEXT in the persistent SQL DB. The callable specified here is responsible for converting the serialised-as-text version of the room unique ID back to the proper type. Common example: `int`.

  DB_POOL_SIZE: int = 5

    Size of the queue pool for sqlalchemy engine. Typically, when using python async libraries, this does not need to be changed. Change that if your gateway use separate threads to call into slidge. The value of this parameter should be equal or greater than the potential number of threads.

  abstractmethod validate(user_jid, registration_form)
    Async:

    Parameters:

      - user_jid (slixmpp.JID)

      - registration_form (dict[str, Optional[str]])

    Return type:

      slidge.db.meta.JSONSerializable | None

    Validate a user’s initial registration form.

    Should raise the appropriate `slixmpp.exceptions.XMPPError` if the registration does not allow to continue the registration process.

    If `REGISTRATION_TYPE` is a `RegistrationType.SINGLE_STEP_FORM`, this method should raise something if it wasn’t possible to successfully log in to the legacy service with the registration form content.

    It is also used for other types of `REGISTRATION_TYPE` too, since the first step is always a form. If `REGISTRATION_FIELDS` is an empty list (ie, it declares no `FormField`), the “form” is effectively a confirmation dialog displaying `REGISTRATION_INSTRUCTIONS`.

    Parameters:

      - user_jid (slixmpp.JID) – JID of the user that has just registered

      - registration_form (dict[str, Optional[str]]) – A dict where keys are the `FormField.var` attributes of the `BaseGateway.REGISTRATION_FIELDS` iterable. This dict can be modified and will be accessible as the `legacy_module_data` of the

    Return type:

      slidge.db.meta.JSONSerializable | None

    :returnA dict that will be stored as the persistent “legacy_module_data”

      for this user. If you don’t return anything here, the whole registration_form content will be stored.

  abstractmethod validate_two_factor_code(user, code)
    Async:

    Parameters:

      - user (slidge.db.GatewayUser)

      - code (str)

    Return type:

      slidge.db.meta.JSONSerializable | None

    Called when the user enters their 2FA code.

    Should raise the appropriate `slixmpp.exceptions.XMPPError` if the login fails, and return successfully otherwise.

    Only used when `REGISTRATION_TYPE` is `RegistrationType.TWO_FACTOR_CODE`.

    Parameters:

      - user (slidge.db.GatewayUser) – The `GatewayUser` whose registration is pending Use their `GatewayUser.bare_jid` and/or `registration_form` attributes to get what you need.

      - code (str) – The code they entered, either via “chatbot” message or adhoc command

    Return type:

      slidge.db.meta.JSONSerializable | None

    :returnA dict which keys and values will be added to the persistent “legacy_module_data”

      for this user.

  abstractmethod get_qr_text(user)
    Async:

    Parameters:

      user (slidge.db.GatewayUser)

    Return type:

      str

    This is where slidge gets the QR code content for the QR-based registration process. It will turn it into a QR code image and send it to the not-yet-fully-registered `GatewayUser`.

    Only used in when `BaseGateway.REGISTRATION_TYPE` is `RegistrationType.QRCODE`.

    Parameters:

      user (slidge.db.GatewayUser) – The `GatewayUser` whose registration is pending Use their `GatewayUser.bare_jid` and/or `registration_form` attributes to get what you need.

    Return type:

      str

  async confirm_qr(user_bare_jid, exception=None, legacy_data=None)

    This method is meant to be called to finalize QR code-based registration flows, once the legacy service confirms the QR flashing.

    Only used in when `BaseGateway.REGISTRATION_TYPE` is `RegistrationType.QRCODE`.

    Parameters:

      - user_bare_jid (str) – The bare JID of the almost-registered `GatewayUser` instance

      - exception (Optional[Exception]) – Optionally, an XMPPError to be raised to not confirm QR code flashing.

      - legacy_data (Optional[slidge.db.meta.JSONSerializable]) – dict which keys and values will be added to the persistent “legacy_module_data” for this user.

    Return type:

      None

  async unregister(session)

    Optionally override this if you need to clean additional stuff after a user has been removed from the persistent user store.

    By default, this just calls `BaseSession.logout()`.

    Parameters:

      session (slidge.core.session.BaseSession) – The session of the user who just unregistered

    Return type:

      None

  async input(jid, text=None, mtype='chat', **input_kwargs)

    Request arbitrary user input using a simple chat message, and await the result.

    You shouldn’t need to call this directly bust instead use `BaseSession.input()` to directly target a user.

    Parameters:

      - jid (slixmpp.JID) – The JID we want input from

      - text (str | None) – A prompt to display for the user

      - mtype (slixmpp.types.MessageTypes) – Message type

      - input_kwargs (Any)

    Returns:

      The user’s reply

    Return type:

      str

  async send_qr(text, **msg_kwargs)

    Sends a QR Code to a JID

    You shouldn’t need to call directly bust instead use `BaseSession.send_qr()` to directly target a user.

    Parameters:

      - text (str) – The text that will be converted to a QR Code

      - msg_kwargs (Any) – Optional additional arguments to pass to `BaseGateway.send_file()`, such as the recipient of the QR, code

    Return type:

      None

  invite_to(muc, reason=None, password=None, **send_kwargs)

    Send an invitation to join a group (XEP-0249) from this XMPP Entity.

    Parameters:

      - muc (slidge.group.LegacyMUC) – the muc the user is invited to

      - reason (Optional[str]) – a text explaining why the user should join this muc

      - password (Optional[str]) – maybe this will make sense later? not sure

      - send_kwargs – additional kwargs to be passed to _send() (internal use by slidge)

    Return type:

      None

  active(**kwargs)

    Send an “active” chat state (XEP-0085) from this XMPP Entity.

    Return type:

      None

  composing(**kwargs)

    Send a “composing” (ie “typing notification”) chat state (XEP-0085) from this XMPP Entity.

    Return type:

      None

  paused(**kwargs)

    Send a “paused” (ie “typing paused notification”) chat state (XEP-0085) from this XMPP Entity.

    Return type:

      None

  inactive(**kwargs)

    Send an “inactive” (ie “contact has not interacted with the chat session interface for an intermediate period of time”) chat state (XEP-0085) from this XMPP Entity.

    Return type:

      None

  gone(**kwargs)

    Send a “gone” (ie “contact has not interacted with the chat session interface, system, or device for a relatively long period of time”) chat state (XEP-0085) from this XMPP Entity.

    Return type:

      None

  ack(legacy_msg_id, **kwargs)

    Send an “acknowledged” message marker (XEP-0333) from this XMPP Entity.

    Parameters:

      legacy_msg_id (slidge.util.types.LegacyMessageType) – The message this marker refers to

    Return type:

      None

  received(legacy_msg_id, **kwargs)

    Send a “received” message marker (XEP-0333) from this XMPP Entity. If called on a `LegacyContact`, also send a delivery receipt marker (XEP-0184).

    Parameters:

      legacy_msg_id (slidge.util.types.LegacyMessageType) – The message this marker refers to

    Return type:

      None

  displayed(legacy_msg_id, **kwargs)

    Send a “displayed” message marker (XEP-0333) from this XMPP Entity.

    Parameters:

      legacy_msg_id (slidge.util.types.LegacyMessageType) – The message this marker refers to

    Return type:

      None

  async send_file(attachment, legacy_msg_id=None, *, reply_to=None, when=None, thread=None, **kwargs)

    Send a single file from this XMPP Entity.

    Parameters:

      - attachment (slidge.util.types.LegacyAttachment | pathlib.Path | str) – The file to send. Ideally, a `LegacyAttachment` with a unique `legacy_file_id` attribute set, to optimise potential future reuses. It can also be: - a `pathlib.Path` instance to point to a local file, or - a `str`, representing a fetchable HTTP URL.

      - legacy_msg_id (Optional[slidge.util.types.LegacyMessageType]) – If you want to be able to transport read markers from the gateway user to the legacy network, specify this

      - reply_to (Optional[slidge.util.types.MessageReference]) – Quote another message (XEP-0461)

      - when (Optional[datetime.datetime]) – when the file was sent, for a “delay” tag (XEP-0203)

      - thread (Optional[slidge.util.types.LegacyThreadType])

    Return type:

      tuple[Optional[str], list[slixmpp.Message]]

  send_text(body, legacy_msg_id=None, *, when=None, reply_to=None, thread=None, hints=None, carbon=False, archive_only=False, correction=False, correction_event_id=None, link_previews=None, **send_kwargs)

    Send a text message from this XMPP Entity.

    Parameters:

      - body (str) – Content of the message

      - legacy_msg_id (Optional[slidge.util.types.LegacyMessageType]) – If you want to be able to transport read markers from the gateway user to the legacy network, specify this

      - when (Optional[datetime.datetime]) – when the message was sent, for a “delay” tag (XEP-0203)

      - reply_to (Optional[slidge.util.types.MessageReference]) – Quote another message (XEP-0461)

      - hints (Optional[Iterable[slidge.util.types.ProcessingHint]])

      - thread (Optional[slidge.util.types.LegacyThreadType])

      - carbon (bool) – (only used if called on a `LegacyContact`) Set this to `True` if this is actually a message sent to the `LegacyContact` by the User. Use this to synchronize outgoing history for legacy official apps.

      - correction (bool) – whether this message is a correction or not

      - correction_event_id (Optional[slidge.util.types.LegacyMessageType]) – in the case where an ID is associated with the legacy ‘correction event’, specify it here to use it on the XMPP side. If not specified, a random ID will be used.

      - link_previews (Optional[list[slidge.util.types.LinkPreview]]) – A little of sender (or server, or gateway)-generated previews of URLs linked in the body.

      - archive_only (bool) – (only in groups) Do not send this message to user, but store it in the archive. Meant to be used during `MUC.backfill()`

  correct(legacy_msg_id, new_text, *, when=None, reply_to=None, thread=None, hints=None, carbon=False, archive_only=False, correction_event_id=None, link_previews=None, **send_kwargs)

    Modify a message that was previously sent by this XMPP Entity.

    Uses last message correction (XEP-0308)

    Parameters:

      - new_text (str) – New content of the message

      - legacy_msg_id (slidge.util.types.LegacyMessageType) – The legacy message ID of the message to correct

      - when (Optional[datetime.datetime]) – when the message was sent, for a “delay” tag (XEP-0203)

      - reply_to (Optional[slidge.util.types.MessageReference]) – Quote another message (XEP-0461)

      - hints (Optional[Iterable[slidge.util.types.ProcessingHint]])

      - thread (Optional[slidge.util.types.LegacyThreadType])

      - carbon (bool) – (only in 1:1) Reflect a message sent to this `Contact` by the user. Use this to synchronize outgoing history for legacy official apps.

      - archive_only (bool) – (only in groups) Do not send this message to user, but store it in the archive. Meant to be used during `MUC.backfill()`

      - correction_event_id (Optional[slidge.util.types.LegacyMessageType]) – in the case where an ID is associated with the legacy ‘correction event’, specify it here to use it on the XMPP side. If not specified, a random ID will be used.

      - link_previews (Optional[list[slidge.util.types.LinkPreview]]) – A little of sender (or server, or gateway)-generated previews of URLs linked in the body.

    Return type:

      None

  react(legacy_msg_id, emojis=(), thread=None, **kwargs)

    Send a reaction (XEP-0444) from this XMPP Entity.

    Parameters:

      - legacy_msg_id (slidge.util.types.LegacyMessageType) – The message which the reaction refers to.

      - emojis (Iterable[str]) – An iterable of emojis used as reactions

      - thread (Optional[slidge.util.types.LegacyThreadType])

    Return type:

      None

  retract(legacy_msg_id, thread=None, **kwargs)

    Send a message retraction (XEP-0424) from this XMPP Entity.

    Parameters:

      - legacy_msg_id (slidge.util.types.LegacyMessageType) – Legacy ID of the message to delete

      - thread (Optional[slidge.util.types.LegacyThreadType])

    Return type:

      None

class slidge.BaseSession(user)

  The session of a registered User.

  Represents a gateway user logged in to the legacy network and performing actions.

  Will be instantiated automatically on slidge startup for each registered user, or upon registration for new (validated) users.

  Must be subclassed for a functional Legacy Module.

  Parameters:

    user (slidge.db.models.GatewayUser)

  xmpp: slidge.core.gateway.BaseGateway

    The gateway instance singleton. Use it for low-level XMPP calls or custom methods that are not session-specific.

  MESSAGE_IDS_ARE_THREAD_IDS = False

    Set this to True if the legacy service uses message IDs as thread IDs, eg Mattermost, where you can only ‘create a thread’ by replying to the message, in which case the message ID is also a thread ID (and all messages are potential threads).

  SPECIAL_MSG_ID_PREFIX: str | None = None

    If you set this, XMPP message IDs starting with this won’t be converted to legacy ID, but passed as is to `on_react()`, and usual checks for emoji restriction won’t be applied. This can be used to implement voting in polls in a hacky way.

  abstractmethod login()
    Async:

    Return type:

      Optional[str]

    Logs in the gateway user to the legacy network.

    Triggered when the gateway start and on user registration. It is recommended that this function returns once the user is logged in, so if you need to await forever (for instance to listen to incoming events), it’s a good idea to wrap your listener in an asyncio.Task.

    Returns:

      Optionally, a text to use as the gateway status, e.g., “Connected as ‘dude@legacy.network’”

    Return type:

      Optional[str]

  abstractmethod logout()
    Async:

    Return type:

      None

    Logs out the gateway user from the legacy network.

    Called on gateway shutdown.

  abstractmethod on_text(chat, text, *, reply_to_msg_id=None, reply_to_fallback_text=None, reply_to=None, thread=None, link_previews=(), mentions=None)
    Async:

    Parameters:

      - chat (slidge.util.types.RecipientType)

      - text (str)

      - reply_to_msg_id (Optional[slidge.util.types.LegacyMessageType])

      - reply_to_fallback_text (Optional[str])

      - reply_to (Optional[slidge.util.types.Sender])

      - thread (Optional[slidge.util.types.LegacyThreadType])

      - link_previews (Iterable[slidge.util.types.LinkPreview])

      - mentions (Optional[list[slidge.util.types.Mention]])

    Return type:

      Optional[slidge.util.types.LegacyMessageType]

    Triggered when the user sends a text message from XMPP to a bridged entity, e.g. to `translated_user_name@slidge.example.com`, or `translated_group_name@slidge.example.com`

    Override this and implement sending a message to the legacy network in this method.

    Parameters:

      - text (str) – Content of the message

      - chat (slidge.util.types.RecipientType) – Recipient of the message. `LegacyContact` instance for 1:1 chat, `MUC` instance for groups.

      - reply_to_msg_id (Optional[slidge.util.types.LegacyMessageType]) – A legacy message ID if the message references (quotes) another message (XEP-0461)

      - reply_to_fallback_text (Optional[str]) – Content of the quoted text. Not necessarily set by XMPP clients

      - reply_to (Optional[slidge.util.types.Sender]) – Author of the quoted message. `LegacyContact` instance for 1:1 chat, `LegacyParticipant` instance for groups. If None, should be interpreted as a self-reply if reply_to_msg_id is not None.

      - link_previews (Iterable[slidge.util.types.LinkPreview]) – A list of sender-generated link previews. At the time of writing, only Cheogram supports it.

      - mentions (Optional[list[slidge.util.types.Mention]]) – (only for groups) A list of Contacts mentioned by their nicknames.

      - thread (Optional[slidge.util.types.LegacyThreadType])

    Returns:

      An ID of some sort that can be used later to ack and mark the message as read by the user

    Return type:

      Optional[slidge.util.types.LegacyMessageType]

  abstractmethod on_file(chat, url, *, http_response, reply_to_msg_id=None, reply_to_fallback_text=None, reply_to=None, thread=None)
    Async:

    Parameters:

      - chat (slidge.util.types.RecipientType)

      - url (str)

      - http_response (aiohttp.ClientResponse)

      - reply_to_msg_id (Optional[slidge.util.types.LegacyMessageType])

      - reply_to_fallback_text (Optional[str])

      - reply_to (Optional[Union[slidge.contact.LegacyContact, slidge.group.participant.LegacyParticipant]])

      - thread (Optional[slidge.util.types.LegacyThreadType])

    Return type:

      Optional[slidge.util.types.LegacyMessageType]

    Triggered when the user sends a file using HTTP Upload (XEP-0363)

    Parameters:

      - url (str) – URL of the file

      - chat (slidge.util.types.RecipientType) – See `BaseSession.on_text()`

      - http_response (aiohttp.ClientResponse) – The HTTP GET response object on the URL

      - reply_to_msg_id (Optional[slidge.util.types.LegacyMessageType]) – See `BaseSession.on_text()`

      - reply_to_fallback_text (Optional[str]) – See `BaseSession.on_text()`

      - reply_to (Optional[Union[slidge.contact.LegacyContact, slidge.group.participant.LegacyParticipant]]) – See `BaseSession.on_text()`

      - thread (Optional[slidge.util.types.LegacyThreadType])

    Returns:

      An ID of some sort that can be used later to ack and mark the message as read by the user

    Return type:

      Optional[slidge.util.types.LegacyMessageType]

  abstractmethod on_sticker(chat, sticker, *, reply_to_msg_id=None, reply_to_fallback_text=None, reply_to=None, thread=None)
    Async:

    Parameters:

      - chat (slidge.util.types.RecipientType)

      - sticker (slidge.util.types.Sticker)

      - reply_to_msg_id (Optional[slidge.util.types.LegacyMessageType])

      - reply_to_fallback_text (Optional[str])

      - reply_to (Optional[Union[slidge.contact.LegacyContact, slidge.group.participant.LegacyParticipant]])

      - thread (Optional[slidge.util.types.LegacyThreadType])

    Return type:

      Optional[slidge.util.types.LegacyMessageType]

    Triggered when the user sends a file using HTTP Upload (XEP-0363)

    Parameters:

      - chat (slidge.util.types.RecipientType) – See `BaseSession.on_text()`

      - sticker (slidge.util.types.Sticker) – The sticker sent by the user.

      - reply_to_msg_id (Optional[slidge.util.types.LegacyMessageType]) – See `BaseSession.on_text()`

      - reply_to_fallback_text (Optional[str]) – See `BaseSession.on_text()`

      - reply_to (Optional[Union[slidge.contact.LegacyContact, slidge.group.participant.LegacyParticipant]]) – See `BaseSession.on_text()`

      - thread (Optional[slidge.util.types.LegacyThreadType])

    Returns:

      An ID of some sort that can be used later to ack and mark the message as read by the user

    Return type:

      Optional[slidge.util.types.LegacyMessageType]

  abstractmethod on_active(chat, thread=None)
    Async:

    Parameters:

      - chat (slidge.util.types.RecipientType)

      - thread (Optional[slidge.util.types.LegacyThreadType])

    Triggered when the user sends an ‘active’ chat state (XEP-0085)

    Parameters:

      - chat (slidge.util.types.RecipientType) – See `BaseSession.on_text()`

      - thread (Optional[slidge.util.types.LegacyThreadType])

  abstractmethod on_inactive(chat, thread=None)
    Async:

    Parameters:

      - chat (slidge.util.types.RecipientType)

      - thread (Optional[slidge.util.types.LegacyThreadType])

    Triggered when the user sends an ‘inactive’ chat state (XEP-0085)

    Parameters:

      - chat (slidge.util.types.RecipientType) – See `BaseSession.on_text()`

      - thread (Optional[slidge.util.types.LegacyThreadType])

  abstractmethod on_composing(chat, thread=None)
    Async:

    Parameters:

      - chat (slidge.util.types.RecipientType)

      - thread (Optional[slidge.util.types.LegacyThreadType])

    Triggered when the user starts typing in a legacy chat (XEP-0085)

    Parameters:

      - chat (slidge.util.types.RecipientType) – See `BaseSession.on_text()`

      - thread (Optional[slidge.util.types.LegacyThreadType])

  abstractmethod on_paused(chat, thread=None)
    Async:

    Parameters:

      - chat (slidge.util.types.RecipientType)

      - thread (Optional[slidge.util.types.LegacyThreadType])

    Triggered when the user pauses typing in a legacy chat (XEP-0085)

    Parameters:

      - chat (slidge.util.types.RecipientType) – See `BaseSession.on_text()`

      - thread (Optional[slidge.util.types.LegacyThreadType])

  abstractmethod on_gone(chat, thread=None)
    Async:

    Parameters:

      - chat (slidge.util.types.RecipientType)

      - thread (Optional[slidge.util.types.LegacyThreadType])

    Triggered when the user is “gone” in a legacy chat (XEP-0085)

    Parameters:

      - chat (slidge.util.types.RecipientType) – See `BaseSession.on_text()`

      - thread (Optional[slidge.util.types.LegacyThreadType])

  abstractmethod on_displayed(chat, legacy_msg_id, thread=None)
    Async:

    Parameters:

      - chat (slidge.util.types.RecipientType)

      - legacy_msg_id (slidge.util.types.LegacyMessageType)

      - thread (Optional[slidge.util.types.LegacyThreadType])

    Triggered when the user reads a message in a legacy chat. (XEP-0333)

    This is only possible if a valid `legacy_msg_id` was passed when transmitting a message from a legacy chat to the user, eg in `slidge.contact.LegacyContact.send_text()` or `slidge.group.LegacyParticipant.send_text()`.

    Parameters:

      - chat (slidge.util.types.RecipientType) – See `BaseSession.on_text()`

      - legacy_msg_id (slidge.util.types.LegacyMessageType) – Identifier of the message/

      - thread (Optional[slidge.util.types.LegacyThreadType])

  abstractmethod on_correct(chat, text, legacy_msg_id, *, thread=None, link_previews=(), mentions=None)
    Async:

    Parameters:

      - chat (slidge.util.types.RecipientType)

      - text (str)

      - legacy_msg_id (slidge.util.types.LegacyMessageType)

      - thread (Optional[slidge.util.types.LegacyThreadType])

      - link_previews (Iterable[slidge.util.types.LinkPreview])

      - mentions (Optional[list[slidge.util.types.Mention]])

    Return type:

      Optional[slidge.util.types.LegacyMessageType]

    Triggered when the user corrects a message using XEP-0308

    This is only possible if a valid `legacy_msg_id` was returned by `on_text()`.

    Parameters:

      - chat (slidge.util.types.RecipientType) – See `BaseSession.on_text()`

      - text (str) – The new text

      - legacy_msg_id (slidge.util.types.LegacyMessageType) – Identifier of the edited message

      - thread (Optional[slidge.util.types.LegacyThreadType])

      - link_previews (Iterable[slidge.util.types.LinkPreview]) –

        A list of sender-generated link previews. At the time of writing, only Cheogram supports it.

      - mentions (Optional[list[slidge.util.types.Mention]]) – (only for groups) A list of Contacts mentioned by their nicknames.

    Return type:

      Optional[slidge.util.types.LegacyMessageType]

  abstractmethod on_react(chat, legacy_msg_id, emojis, thread=None)
    Async:

    Parameters:

      - chat (slidge.util.types.RecipientType)

      - legacy_msg_id (slidge.util.types.LegacyMessageType)

      - emojis (list[str])

      - thread (Optional[slidge.util.types.LegacyThreadType])

    Triggered when the user sends message reactions (XEP-0444).

    Parameters:

      - chat (slidge.util.types.RecipientType) – See `BaseSession.on_text()`

      - thread (Optional[slidge.util.types.LegacyThreadType])

      - legacy_msg_id (slidge.util.types.LegacyMessageType) – ID of the message the user reacts to

      - emojis (list[str]) – Unicode characters representing reactions to the message `legacy_msg_id`. An empty string means “no reaction”, ie, remove all reactions if any were present before

  abstractmethod on_retract(chat, legacy_msg_id, thread=None)
    Async:

    Parameters:

      - chat (slidge.util.types.RecipientType)

      - legacy_msg_id (slidge.util.types.LegacyMessageType)

      - thread (Optional[slidge.util.types.LegacyThreadType])

    Triggered when the user retracts (XEP-0424) a message.

    Parameters:

      - chat (slidge.util.types.RecipientType) – See `BaseSession.on_text()`

      - thread (Optional[slidge.util.types.LegacyThreadType])

      - legacy_msg_id (slidge.util.types.LegacyMessageType) – Legacy ID of the retracted message

  abstractmethod on_presence(resource, show, status, resources, merged_resource)
    Async:

    Parameters:

      - resource (str)

      - show (slidge.util.types.PseudoPresenceShow)

      - status (str)

      - resources (dict[str, slixmpp.types.ResourceDict])

      - merged_resource (Optional[slixmpp.types.ResourceDict])

    Called when the gateway component receives a presence, ie, when one of the user’s clients goes online of offline, or changes its status.

    Parameters:

      - resource (str) – The XMPP client identifier, arbitrary string.

      - show (slidge.util.types.PseudoPresenceShow) – The presence `<show>`, if available. If the resource is just ‘available’ without any `<show>` element, this is an empty str.

      - status (str) – A status message, like a deeply profound quote, eg, “Roses are red, violets are blue, [INSERT JOKE]”.

      - resources (dict[str, slixmpp.types.ResourceDict]) – A summary of all the resources for this user.

      - merged_resource (Optional[slixmpp.types.ResourceDict]) – A global presence for the user account, following rules described in `merge_resources()`

  abstractmethod on_search(form_values)
    Async:

    Parameters:

      form_values (dict[str, str])

    Return type:

      Optional[slidge.command.SearchResult]

    Triggered when the user uses Jabber Search (XEP-0055) on the component

    Form values is a dict in which keys are defined in `BaseGateway.SEARCH_FIELDS`

    Parameters:

      form_values (dict[str, str]) – search query, defined for a specific plugin by overriding in `BaseGateway.SEARCH_FIELDS`

    Returns:

    Return type:

      Optional[slidge.command.SearchResult]

  abstractmethod on_avatar(bytes_, hash_, type_, width, height)
    Async:

    Parameters:

      - bytes_ (Optional[bytes])

      - hash_ (Optional[str])

      - type_ (Optional[str])

      - width (Optional[int])

      - height (Optional[int])

    Return type:

      None

    Triggered when the user uses modifies their avatar via XEP-0084.

    Parameters:

      - bytes – The data of the avatar. According to the spec, this should always be a PNG, but some implementations do not respect that. If None it means the user has unpublished their avatar.

      - hash – The SHA1 hash of the avatar data. This is an identifier of the avatar.

      - type – The MIME type of the avatar.

      - width (Optional[int]) – The width of the avatar image.

      - height (Optional[int]) – The height of the avatar image.

      - bytes_ (Optional[bytes])

      - hash_ (Optional[str])

      - type_ (Optional[str])

    Return type:

      None

  abstractmethod on_moderate(muc, legacy_msg_id, reason)
    Async:

    Parameters:

      - muc (slidge.group.room.LegacyMUC)

      - legacy_msg_id (slidge.util.types.LegacyMessageType)

      - reason (Optional[str])

    Triggered when the user attempts to retract a message that was sent in a MUC using XEP-0425.

    If retraction is not possible, this should raise the appropriate XMPPError with a human-readable message.

    NB: the legacy module is responsible for calling :method:`LegacyParticipant.moderate` when this is successful, because slidge will acknowledge the moderation IQ, but will not send the moderation message from the MUC automatically.

    Parameters:

      - muc (slidge.group.room.LegacyMUC) – The MUC in which the message was sent

      - legacy_msg_id (slidge.util.types.LegacyMessageType) – The legacy ID of the message to be retracted

      - reason (Optional[str]) – Optionally, a reason for the moderation, given by the user-moderator.

  abstractmethod on_create_group(name, contacts)
    Async:

    Parameters:

      - name (str)

      - contacts (list[slidge.contact.LegacyContact])

    Return type:

      slidge.util.types.LegacyGroupIdType

    Triggered when the user request the creation of a group via the dedicated Command.

    Parameters:

      - name (str) – Name of the group

      - contacts (list[slidge.contact.LegacyContact]) – list of contacts that should be members of the group

    Return type:

      slidge.util.types.LegacyGroupIdType

  async on_invitation(contact, muc, reason)

    Triggered when the user invites a Contact to a legacy MUC via XEP-0249.

    The default implementation calls `LegacyMUC.on_set_affiliation()` with the ‘member’ affiliation. Override if you want to customize this behaviour.

    Parameters:

      - contact (slidge.contact.LegacyContact) – The invitee

      - muc (slidge.group.room.LegacyMUC) – The group

      - reason (Optional[str]) – Optionally, a reason

    Return type:

      None

  abstractmethod on_leave_group(muc_legacy_id)
    Async:

    Parameters:

      muc_legacy_id (slidge.util.types.LegacyGroupIdType)

    Triggered when the user leaves a group via the dedicated slidge command or the XEP-0077 `<remove />` mechanism.

    This should be interpreted as definitely leaving the group.

    Parameters:

      muc_legacy_id (slidge.util.types.LegacyGroupIdType) – The legacy ID of the group to leave

  abstractmethod on_preferences(previous, new)
    Async:

    Parameters:

      - previous (dict[str, Any])

      - new (dict[str, Any])

    Return type:

      None

    This is called when the user updates their preferences.

    Override this if you need set custom preferences field and need to trigger something when a preference has changed.

  static legacy_to_xmpp_msg_id(legacy_msg_id)

    Convert a legacy msg ID to a valid XMPP msg ID. Needed for read marks, retractions and message corrections.

    The default implementation just converts the legacy ID to a `str`, but this should be overridden in case some characters needs to be escaped, or to add some additional, legacy network <Legacy Network>-specific logic.

    Parameters:

      legacy_msg_id (slidge.util.types.LegacyMessageType)

    Returns:

      A string that is usable as an XMPP stanza ID

    Return type:

      str

  static xmpp_to_legacy_msg_id(i)

    Convert a legacy XMPP ID to a valid XMPP msg ID. Needed for read marks and message corrections.

    The default implementation just converts the legacy ID to a `str`, but this should be overridden in case some characters needs to be escaped, or to add some additional, legacy network <Legacy Network>-specific logic.

    The default implementation is an identity function.

    Parameters:

      i (str) – The XMPP stanza ID

    Returns:

      An ID that can be used to identify a message on the legacy network

    Return type:

      slidge.util.types.LegacyMessageType

  send_gateway_status(status=None, show=Optional[PresenceShows], **kwargs)

    Send a presence from the gateway to the user.

    Can be used to indicate the user session status, ie “SMS code required”, “connected”, …

    Parameters:

      - status (Optional[str]) – A status message

      - show – Presence stanza ‘show’ element. I suggest using “dnd” to show that the gateway is not fully functional

    Return type:

      None

  send_gateway_message(text, **msg_kwargs)

    Send a message from the gateway component to the user.

    Can be used to indicate the user session status, ie “SMS code required”, “connected”, …

    Parameters:

      text (str) – A text

    Return type:

      None

  send_gateway_invite(muc, reason=None, password=None)

    Send an invitation to join a MUC, emanating from the gateway component.

    Parameters:

      - muc (slidge.group.room.LegacyMUC)

      - reason (Optional[str])

      - password (Optional[str])

    Return type:

      None

  async input(text, **msg_kwargs)

    Request user input via direct messages from the gateway component.

    Wraps call to `BaseSession.input()`

    Parameters:

      - text (str) – The prompt to send to the user

      - msg_kwargs – Extra attributes

    Returns:

  async send_qr(text)

    Sends a QR code generated from ‘text’ via HTTP Upload and send the URL to `self.user`

    Parameters:

      text (str) – Text to encode as a QR code

    Return type:

      None

slidge.entrypoint(module_name)

  Entrypoint to be used in `__main__.py` of legacy modules.

  Parameters:

    module_name (str) – An importable Legacy Module.

  Return type:

    None